## openjdk-21 21.0.5+11

=== debian/changelog ===
openjdk-21 (21.0.5+11-1ubuntu1~22.04) jammy-security; urgency=medium

  * d/control: Regenerate for upload to Ubuntu 22.04
  * d/rules: Add CFLAG to avert FTBFS on armhf due
    to GCC-11 ICE reported by LP-1953128
  * d/changelog: Add additional CVE information to the
    21.0.5+11 changelog entry
  * Upload to Ubuntu 22.04

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Tue, 22 Oct 2024 14:15:11 +0530

openjdk-21 (21.0.5+11-1) unstable; urgency=high

  * OpenJDK 21.0.5 release, build 8.

    - CVEs
      + CVE-2024-21208, 8328286: Enhance HTTP client
      + CVE-2024-21210, 8328544: Improve handling of vectorization
      + CVE-2024-21217, 8331446: Improve deserialization support
      + CVE-2024-21235, 8332644: Improve graph optimizations

  [ Vladimir Petko ]
  * d/rules: do not include dtrace support for S390x (JDK-8305174).
  * d/t/problems.csv: Disable jdk/sun/security/util/Debug/DebugOptions.java
    due to JDK-8339713.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 16 Oct 2024 10:41:47 +0200

=== debian/control ===
Source: openjdk-21
Section: java
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: OpenJDK Team <openjdk-21@packages.debian.org>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper (>= 11),
  m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, procps, wdiff, pkg-config, fastjar (>= 2:0.96-0ubuntu2),
  time, strip-nondeterminism, debugedit (>= 4.16),
  jtreg7 (>= 7.3.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
  autoconf, automake, ant, ant-optional,
  g++-12 <!cross>,
  openjdk-20-jdk-headless:native | openjdk-21-jdk-headless:native,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
  libffi-dev, libffi-dev:native,
  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!sh4 !s390x],
  libnss3-dev (>= 2:3.17.1),
  openjdk-21-jdk-headless <cross>,
Build-Depends-Indep: graphviz, pandoc,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://openjdk.java.net/
Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk/tree/openjdk-21
Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git -b openjdk-21

Package: openjdk-21-jdk-headless
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-21-demo, openjdk-21-source
Provides: java-sdk-headless (= ${vm:Version}), java2-sdk-headless,
  java5-sdk-headless, java6-sdk-headless,
  java7-sdk-headless, java8-sdk-headless,
  java9-sdk-headless, java10-sdk-headless,
  java11-sdk-headless, java12-sdk-headless,
  java13-sdk-headless, java14-sdk-headless, java15-sdk-headless,
  java16-sdk-headless, java17-sdk-headless,
  java18-sdk-headless, java19-sdk-headless,
  java20-sdk-headless, java21-sdk-headless,
  java-compiler
Breaks: openjdk-17-jre-headless (<< 17~10), openjdk-21-jre-headless (<< 21~27ea),
Replaces: openjdk-17-jre-headless (<< 17~10), openjdk-21-jre-headless (<< 21~27ea),
Description: OpenJDK Development Kit (JDK) (headless)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-21-jre-headless
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenhl:Recommends},
  ${fontmanager:Recommends}, ${jsound:Recommends}
Suggests: libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
Provides: java-runtime-headless (= ${vm:Version}), java2-runtime-headless,
  java5-runtime-headless, java6-runtime-headless,
  java7-runtime-headless, java8-runtime-headless,
  java9-runtime-headless, java10-runtime-headless,
  java11-runtime-headless, java12-runtime-headless,
  java13-runtime-headless, java14-runtime-headless, java15-runtime-headless,
  java16-runtime-headless, java17-runtime-headless,
  java19-runtime-headless, java20-runtime-headless,
  java21-runtime-headless,
  ${defaultvm:Provides}, ${jvm:Provides}
Breaks: ${jrehl:Breaks}
Conflicts: oracle-java11-installer, openjdk-11-jdk-headless (<< 11~18-2)
Replaces: openjdk-11-jdk-headless (<< 11~18-2)
Description: OpenJDK Java runtime, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}.

Package: openjdk-21-jdk
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre (= ${binary:Version}),
  openjdk-21-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-21-demo, openjdk-21-source, visualvm
Provides: java-sdk (= ${vm:Version}), java2-sdk, java5-sdk, java6-sdk,
  java7-sdk, java8-sdk, java9-sdk, java10-sdk, java11-sdk,
  java12-sdk, java13-sdk, java14-sdk, java15-sdk, java16-sdk, java17-sdk,
  java18-sdk, java19-sdk, java20-sdk, java21-sdk,
  java-compiler
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-21-jre
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre-headless (= ${binary:Version}),
  ${dlopenjre:Depends}, ${fontmanager:Depends}, ${jsound:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
Provides: java-runtime (= ${vm:Version}), java2-runtime,
  java5-runtime, java6-runtime,
  java7-runtime, java8-runtime,
  java9-runtime, java10-runtime,
  java11-runtime, java12-runtime,
  java13-runtime, java14-runtime, java15-runtime,
  java16-runtime, java17-runtime,
  java18-runtime, java19-runtime,
  java20-runtime, java21-runtime,
Breaks: openjdk-17-jre-headless (<< 17~10)
Replaces: openjdk-17-jre-headless (<< 17~10)
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}.

Package: openjdk-21-demo
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-21-source
Architecture: all
Multi-Arch: foreign
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jdk (>= ${source:Version}),
  ${misc:Depends}
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-21-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-jquery-ui,
  libjs-jquery-ui-theme-base,
Suggests: openjdk-21-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-21-dbg
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Priority: optional
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre-headless (= ${binary:Version}),
   ${misc:Depends},${shlibs:Depends}
Recommends: openjdk-21-jre (= ${binary:Version})
Suggests: openjdk-21-jdk (= ${binary:Version})
Conflicts: ${dbg:Conflicts}
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-21-testsupport
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Depends: openjdk-21-jdk (= ${binary:Version}),
  build-essential, xfwm4, xvfb, dbus-x11, libatk-wrapper-java,
  libatk-wrapper-java-jni, jtreg7 (>= 7.3.1+1~), libtestng7-java,
  ${shlibs:Depends},
  ${misc:Depends}
Description: Java runtime based on OpenJDK (regression test support)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains all the binary files needed to run the
 OpenJDK autopkg tests.

Package: openjdk-21-jre-zero
Architecture: amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-21-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero
 The package provides an alternative runtime using the Zero VM. Built on
 architectures in addition to the Hotspot VM as a debugging aid for those
 architectures which don't have a Hotspot VM.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
include /usr/share/dpkg/buildflags.mk

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

# use gnu time in verbose mode if available, otherwise default to the shell builtin
ifneq (,$(wildcard /usr/bin/time))
  TIME = /usr/bin/time -v
else
  TIME = time
endif

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
PKGYEAR := $(shell echo $(call vafilt,$(CHANGELOG_VARS),Timestamp) | date --utc +%Y)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

ifneq (,$(filter $(distrel),precise))
  OBJCOPY := objcopy
  STRIP := strip
else
  OBJCOPY := $(DEB_HOST_GNU_TYPE)-objcopy
  STRIP := $(DEB_HOST_GNU_TYPE)-strip
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
jtreg_archs	+= armel loong64 mipsel mips64el
jtreg_archs	+= riscv64

# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
#bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
#bootcycle_build =
zbootcycle_build =
zbootcycle_build = yes
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif
ifneq (,$(filter nobootcycle, $(DEB_BUILD_OPTIONS)))
  bootcycle_build =
  zbootcycle_build =
endif

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

is_upstream_release = yes

srcdir		= .
builddir	= build
zbuilddir	= build-zero

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk
basename	= openjdk-$(shortver)
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),2111,2109)
  vm_name	= Hotspot JIT
else
  priority	= $(if $(filter yes, $(is_default)),2104,2103)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.21.0
shortver	= 21
v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//' | sed 's/\~us[[:digit:]]\+//')
v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')

ifeq (yes,$(is_upstream_release))
  v_upbase      := $(word 1, $(subst +, , $(v_upstream)))
  v_upbuild     := $(word 2, $(subst +, , $(v_upstream)))
  ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
    $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
  endif
else
  v_upbase      := $(word 1, $(subst ~, , $(v_upstream)))
  v_upbuild     := $(word 2, $(subst ~, , $(v_upstream)))
  ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
    $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
  endif
endif

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
  testsuitedir	=	$(basedir)/testsuite
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
  testsuitedir	=	$(basedir)/testsuite
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images test-image
  testimg	= images/test
else
  sdkimg	= images/jdk
  build_target	= images test-image
  testimg	= images/test
endif
ifeq ($(zbootcycle_build),yes)
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images test-image
else
  zsdkimg	= images/jdk
  zbuild_target	= images test-image
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

ifneq (,$(filter $(distrel), sid bookworm bullseye))
  jtreg_pkg = jtreg# debian will have jtreg7 in jtreg package
  testng_pkg = libtestng7-java
else
  jtreg_pkg = jtreg7
  testng_pkg = libtestng7-java
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(DEB_HOST_ARCH), alpha arc hppa armel ia64 loong64 mipsel mips64el powerpc riscv64 x32))
  with_check = disabled running check on $(DEB_HOST_ARCH)
endif
# no jtreg backport yet
ifneq (,$(filter $(distrel), precise trusty xenial bionic bookworm bullseye))
  with_check = disabled for $(distrel), no $(jtreg_pkg)
endif
#with_check = disabled, more recent jtreg needed

with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(distrel), precise trusty))
  with_docs =
endif
#with_check = disabled for this upload

with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arc=arc arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 loong64=loong64 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

altzero_archs = $(hotspot_archs)
ifneq (,$(filter $(distrel),trusty))
  altzero_archs := $(filter-out arm64, $(altzero_archs))
endif

ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
  altzero_archs =
else ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
  alternate_vms += zero
  zero_dir = zero
endif

# needed for the jexec build
export DEBIAN_JDK_BASE_DIR := /$(basedir)

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-21-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-20-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
		))))

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
else
  BUILDJDK_HOME = $(BOOTJDK_HOME)
endif

ifneq (,$(filter $(distrel),saucy))
  export CC = gcc-4.8
  export CXX = g++-4.8
  bd_gcc = g++-4.8,
else ifneq (,$(filter $(distrel),utopic vivid jessie))
  export CC = gcc-4.9
  export CXX = g++-4.9
  bd_gcc = g++-4.9,
else ifneq (,$(filter $(distrel),wily))
  ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
    export CC = $(DEB_HOST_GNU_TYPE)-gcc-5
    export CXX = $(DEB_HOST_GNU_TYPE)-g++-5

## openjdk-21 21.0.6~6ea

=== debian/changelog ===
openjdk-21 (21.0.6~6ea-1ubuntu2) plucky; urgency=medium

  * d/rules: Add -fno-delete-null-pointer-checks for armhf and armel.
    The flag was removed in JDK-8316893 causing JVM lockup.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Thu, 16 Jan 2025 13:41:54 +1300

openjdk-21 (21.0.6~6ea-1ubuntu1) plucky; urgency=medium

  [ Vladimir Petko ]
  * d/rules: disable c2 compiler for boot jdk on s390x to avoid ftbfs.

  [ Matthias Klose ]
  * Try to work-around a ftbfs on alpha.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 15:12:34 +0100

openjdk-21 (21.0.6~6ea-1) unstable; urgency=medium

  * OpenJDK 21.0.6 early access, build 6.
  * Really configure with --enable-dtrace on !s390x.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 20 Dec 2024 09:54:05 +0100

=== debian/rules ===
--- 
+++ 
@@ -83,6 +83,7 @@
 endif
 
 is_upstream_release = yes
+is_upstream_release =
 
 srcdir		= .
 builddir	= build

## openjdk-21 21.0.6+7

=== debian/changelog ===
openjdk-21 (21.0.6+7-1) unstable; urgency=high

  * OpenJDK 21.0.6 release, build 7. Release notes:
    https://mail.openjdk.org/pipermail/jdk-updates-dev/2025-January/040828.html
    - CVEs:
      +  CVE-2025-21502 - 8330045: Enhance array handling.

  [ Vladimir Petko ]
  * d/rules: disable c2 compiler for boot jdk on s390x to avoid ftbfs.
  * d/p/jdk-8347014-proposed.patch: Define MAP_FIXED_NOREPLACE_value for alpha.
  * d/rules: Add -fno-delete-null-pointer-checks for armhf and armel.
    The flag was removed in JDK-8316893 causing JVM lockup.
  * d/rules: Dump complete hs_err_pid and replay_pid logs to stdout.
  * d/rules: create link to jquery-3.7.1.min.js instead of jquery-3.6.1.min.js.
    Also link jquery-ui.min.{js,css} (LP: #2095455).
  * d/{watch,copyright}: regenerate.

  [ Matthias Klose ]
  * Try to work-around a ftbfs on alpha. For now we keep the
    zero-alpha-workaround patch enabled instead of jdk-8347014-proposed.
  * d/rules: Also dump logs for zero builds and for build failures.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 22 Jan 2025 08:58:11 +0100

=== debian/rules ===
--- 
+++ 
@@ -83,7 +83,6 @@
 endif
 
 is_upstream_release = yes
-is_upstream_release =
 
 srcdir		= .
 builddir	= build

## openjdk-21 21.0.7~7ea

=== debian/changelog ===
openjdk-21 (21.0.7~7ea-1) unstable; urgency=medium

  * OpenJDK 21.0.7 early access, build 4.

  [ Vladimir Petko ]
  * d/t/problems.csv: Synchronize problemlist with the master branch.
  * d/rules: Disable dtrace on jammy armhf (was not enabled before and cannot
    be built due to a GCC ICE (see LP #2091225).

 -- Matthias Klose <doko@ubuntu.com>  Sat, 15 Mar 2025 08:27:31 +0100

=== debian/rules ===
--- 
+++ 
@@ -83,6 +83,7 @@
 endif
 
 is_upstream_release = yes
+is_upstream_release =
 
 srcdir		= .
 builddir	= build

## openjdk-21 21.0.7~8ea

=== debian/changelog ===
openjdk-21 (21.0.7~8ea-1) unstable; urgency=medium

  [ NOTE: This really is 21.0.7~5ea-1, the version in the last upload was wrong]
  * OpenJDK 21.0.7 early access, build 5.

  [ Vladimir Petko ]
  * d/t/problems.csv: Disable tests failing due to upstream bugs.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 27 Mar 2025 12:19:44 +0100

## openjdk-21 21.0.7+6~us1

=== test/jdk/performance/client/SwingMark/Makefile ===
#
# Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
#   - Neither the name of Oracle nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
# IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SOURCEPATH=src
CLASSES=build
DIST=dist
RESOURCES=resources

SWINGMARK_CLASSES = \
	$(CLASSES)/AbstractSwingTest.class \
	$(CLASSES)/AdvancedTextAreaTest.class \
	$(CLASSES)/InternalFrameTest.class \
	$(CLASSES)/JMTest_01.class \
	$(CLASSES)/JMTest_02.class \
	$(CLASSES)/JMTest_03.class \
	$(CLASSES)/JMTest_04.class \
	$(CLASSES)/JMTest_05.class \
	$(CLASSES)/LabelTest.class \
	$(CLASSES)/ListTest.class \
	$(CLASSES)/MenuTest.class \
	$(CLASSES)/NullRunnable.class \
	$(CLASSES)/SliderTest.class \
	$(CLASSES)/SwingMark.class \
	$(CLASSES)/SwingMarkPanel.class \
	$(CLASSES)/TableColMoveTest.class \
	$(CLASSES)/TableColTest.class \
	$(CLASSES)/TableRowTest.class \
	$(CLASSES)/TableScrollTest.class \
	$(CLASSES)/TextAreaTest.class \
	$(CLASSES)/TextPaneTest.class \
	$(CLASSES)/TreeTest.class \
	$(CLASSES)/TypingTest.class \
        $(CLASSES)/resources/TableRowTest.class \
        $(CLASSES)/resources/TableRowTest_ja.class

SWINGMARK_RESOURCES = \
	$(CLASSES)/resources/TestList.txt \
	$(CLASSES)/resources/JMTest_04.properties \
	$(CLASSES)/resources/JMTest_04_ja.properties \
	$(CLASSES)/resources/ListTest.properties \
	$(CLASSES)/resources/ListTest_ja.properties \
	$(CLASSES)/resources/TextAreaTest.properties \
	$(CLASSES)/resources/TextAreaTest_ja.properties

all: mkdirs SwingMark.jar

run: mkdirs SwingMark.jar
	cd $(DIST) && java -jar SwingMark.jar -q

SwingMark.jar: \
	$(SWINGMARK_CLASSES) \
	$(SWINGMARK_RESOURCES) \
	$(CLASSES)/swingmark.manifest
	jar cvmf $(CLASSES)/swingmark.manifest $(DIST)/SwingMark.jar -C $(CLASSES) .

$(CLASSES)/swingmark.manifest:
	echo "Main-Class: SwingMark" > $@

$(DIST):
	mkdir $(DIST)

$(CLASSES):
	mkdir $(CLASSES)

mkdirs: $(DIST) $(CLASSES)

$(CLASSES)/%.class: $(SOURCEPATH)/%.java
	javac -d $(CLASSES) -sourcepath $(SOURCEPATH) $<

$(CLASSES)/resources/%.properties: $(SOURCEPATH)/resources/%.properties
	cp -r $< $@

$(CLASSES)/resources/TestList.txt: $(SOURCEPATH)/resources/TestList.txt
	cp -r $< $@
	
clean:
	rm -rf $(CLASSES)
	rm -rf $(DIST)

=== debian/changelog ===
openjdk-21 (21.0.7+6~us1-0ubuntu1~20.04) focal-security; urgency=medium

  * OpenJDK 21.0.7 release, build 6. Release notes:
    https://mail.openjdk.org/pipermail/jdk-updates-dev/2025-April/043308.html

    - CVEs:
      + CVE-2025-21587
      + CVE-2025-30691
      + CVE-2025-30698

  [ Matthias Klose ]
  * Honour DEB_BUILD_OPTIONS=parallel=N while running jtreg tests (Helmut
    Grohne). Addresses: #1095920.

  [ Pushkar Kulkarni ]
  * d/control: regenerate for Ubuntu 20.04
  * Upload to Ubuntu 20.04

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Thu, 17 Apr 2025 11:27:30 +0530

=== debian/control ===
--- 
+++ 
@@ -7,14 +7,14 @@
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, procps, wdiff, pkg-config, fastjar (>= 2:0.96-0ubuntu2),
-  time, strip-nondeterminism, debugedit (>= 4.16),
+  time, strip-nondeterminism,
   jtreg7 (>= 7.3.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
   autoconf, automake, ant, ant-optional,
-  g++-12 <!cross>,
+  g++-10 <!cross>,
   openjdk-20-jdk-headless:native | openjdk-21-jdk-headless:native,
-  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
+  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libfreetype-dev, libharfbuzz-dev,
   libffi-dev, libffi-dev:native,
-  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!sh4 !s390x],
+  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!powerpc !ppc64 !ppc64el !sh4 !s390x],
   libnss3-dev (>= 2:3.17.1),
   openjdk-21-jdk-headless <cross>,
 Build-Depends-Indep: graphviz, pandoc,

=== debian/rules ===
--- 
+++ 
@@ -83,7 +83,7 @@
 endif
 
 is_upstream_release = yes
-is_upstream_release =
+#is_upstream_release =
 
 srcdir		= .
 builddir	= build

## openjdk-21 21.0.7+6

=== debian/changelog ===
openjdk-21 (21.0.7+6-1) unstable; urgency=high

  * OpenJDK 21.0.7 release, build 6.
    - Addresses CVE-2025-30698, CVE-2025-30691, CVE-2025-21587.

  * Honour DEB_BUILD_OPTIONS=parallel=N while running jtreg tests (Helmut
    Grohne). Addresses: #1095920.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 24 Apr 2025 01:57:46 +0200

## openjdk-21 21.0.8~5ea

=== debian/changelog ===
openjdk-21 (21.0.8~5ea-1) unstable; urgency=medium

  * OpenJDK 21.0.8 early access, build 5.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Jun 2025 13:05:25 +0200

=== debian/rules ===
--- 
+++ 
@@ -83,7 +83,7 @@
 endif
 
 is_upstream_release = yes
-#is_upstream_release =
+is_upstream_release =
 
 srcdir		= .
 builddir	= build

## openjdk-21 21.0.8%2B9~us1

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,13 @@
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,
-  sharutils, gawk, cpio, procps, wdiff, pkg-config, fastjar (>= 2:0.96-0ubuntu2),
-  time, strip-nondeterminism,
+  sharutils, gawk, cpio, procps, wdiff, pkgconf, fastjar (>= 2:0.96-0ubuntu2),
+  time, strip-nondeterminism, debugedit (>= 4.16),
   jtreg7 (>= 7.3.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
   autoconf, automake, ant, ant-optional,
-  g++-10 <!cross>,
-  openjdk-20-jdk-headless:native | openjdk-21-jdk-headless:native,
-  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libfreetype-dev, libharfbuzz-dev,
+  g++-13 <!cross>,
+  openjdk-21-jdk-headless:native | openjdk-20-jdk-headless:native,
+  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
   libffi-dev, libffi-dev:native,
   zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!powerpc !ppc64 !ppc64el !sh4 !s390x],
   libnss3-dev (>= 2:3.17.1),

=== debian/watch ===
version=4
opts=\
repack,\
compression=xz, \
    https://github.com/openjdk/jdk21u/tags \
    (?:.*?/)?jdk-(21[\+\.\d]*)\.tar\.gz

opts=\
component=googletest,\
repack,\
compression=xz \
    https://github.com/google/googletest/tags \
    (?:.*?/)?v(1.14.0)\.tar\.gz 1.14.0

## openjdk-21 21.0.8+9~us1

=== debian/changelog ===
openjdk-21 (21.0.8+9~us1-0ubuntu1~22.04.1) jammy-security; urgency=medium

  * Upload to Ubuntu 22.04.
  * CVEs:
    - CVE-2025-50059, 8350991: Improve HTTP client header handling
    - CVE-2025-30749, 8348989: Better Glyph drawing
    - CVE-2025-50106, 8360147: Better Glyph drawing redux
    - CVE-2025-30754, 8349594: Enhance TLS protocol support
  * Security fixes:
    - 8349111: Enhance Swing supports
    - 8345625: Better HTTP connections

 -- Vladimir Petko <vladimir.petko@canonical.com>  Thu, 17 Jul 2025 09:56:18 +1200

openjdk-21 (21.0.8+9~us1-0ubuntu1) questing; urgency=medium

  * OpenJDK 21.0.8 release, build 9.
    - Addresses CVE-2025-50059, CVE-2025-30749, CVE-2025-50106,
      CVE-2025-30754. See
      https://openjdk.org/groups/vulnerability/advisories/2025-07-15
    - Release notes:
      https://mail.openjdk.org/pipermail/jdk-updates-dev/2025-July/045617.html
  * d/copyright: regenerate.
  * d/copyright-generator/copyright-gen.py: bump copyright year.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Wed, 16 Jul 2025 09:35:15 +1200

openjdk-21 (21.0.8~8ea-0ubuntu1) questing; urgency=medium

  * OpenJDK 21.0.8 early access, build 8.
  * d/p/jdk-8359735.patch: fix process tests failing in Ubuntu 25.10
    (questing).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Sat, 05 Jul 2025 18:50:10 +1200

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,12 @@
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,
-  sharutils, gawk, cpio, procps, wdiff, pkgconf, fastjar (>= 2:0.96-0ubuntu2),
+  sharutils, gawk, cpio, procps, wdiff, pkg-config, fastjar (>= 2:0.96-0ubuntu2),
   time, strip-nondeterminism, debugedit (>= 4.16),
   jtreg7 (>= 7.3.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
   autoconf, automake, ant, ant-optional,
-  g++-13 <!cross>,
-  openjdk-21-jdk-headless:native | openjdk-20-jdk-headless:native,
+  g++-12 <!cross>,
+  openjdk-20-jdk-headless:native | openjdk-21-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
   libffi-dev, libffi-dev:native,
   zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!powerpc !ppc64 !ppc64el !sh4 !s390x],

=== debian/rules ===
--- 
+++ 
@@ -83,7 +83,6 @@
 endif
 
 is_upstream_release = yes
-is_upstream_release =
 
 srcdir		= .
 builddir	= build

## openjdk-21 21.0.8+9

=== debian/changelog ===
openjdk-21 (21.0.8+9-1) unstable; urgency=high

  * OpenJDK 21.0.8 release, build 9.
    - Addresses CVE-2025-5010, CVE-2025-50059, CVE-2025-30754, CVE-2025-30749.

  [ Vladimir Petko ]
  * d/p/jdk-8359735-proposed.patch: Fix process tests failing in Ubuntu 25.10.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Jul 2025 16:12:28 +0200

=== debian/rules ===
--- 
+++ 
@@ -83,6 +83,7 @@
 endif
 
 is_upstream_release = yes
+#is_upstream_release =
 
 srcdir		= .
 builddir	= build

## openjdk-21 21.0.9~5ea

=== debian/changelog ===
openjdk-21 (21.0.9~5ea-1) unstable; urgency=medium

  * OpenJDK 21.0.9 early access, build 5.

  [ Vladimir Petko ]
  * d/copyright-generator/copyright-gen.py: bump copyright year.
  * d/copyright: regenerate.

  [ Matthias Klose ]
  * Build using GCC 15 on development releases.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 29 Aug 2025 12:59:33 +0200

=== debian/rules ===
--- 
+++ 
@@ -83,7 +83,7 @@
 endif
 
 is_upstream_release = yes
-#is_upstream_release =
+is_upstream_release =
 
 srcdir		= .
 builddir	= build

## openjdk-21 21.0.9~8ea

=== test/hotspot/jtreg/testlibrary/ctw/Makefile ===
#
# Copyright (c) 2013, 2023, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
#

ifneq "x$(ALT_BOOTDIR)" "x"
	BOOTDIR := $(ALT_BOOTDIR)
endif

ifeq "x$(BOOTDIR)" "x"
	JDK_HOME := $(shell dirname $(shell which java))/..
else
	JDK_HOME := $(BOOTDIR)
endif

SRC_DIR = src
BUILD_DIR = build
DST_DIR = dist
OUTPUT_DIR = $(BUILD_DIR)/classes
TESTLIBRARY_DIR = ../../../../../test/lib

JAVAC = $(JDK_HOME)/bin/javac
JAR = $(JDK_HOME)/bin/jar

SRC_FILES = $(shell find $(SRC_DIR) -name '*.java')
LIB_FILES = $(shell find $(TESTLIBRARY_DIR)/jdk/test/lib/ \
    $(TESTLIBRARY_DIR)/jdk/test/lib/process \
    $(TESTLIBRARY_DIR)/jdk/test/lib/util \
    $(TESTLIBRARY_DIR)/jtreg \
    -maxdepth 1 -name '*.java')
WB_SRC_FILES = $(shell find $(TESTLIBRARY_DIR)/jdk/test/lib/compiler $(TESTLIBRARY_DIR)/jdk/test/whitebox -name '*.java')
WB_CLASS_FILES := $(subst $(TESTLIBRARY_DIR)/,,$(WB_SRC_FILES))
WB_CLASS_FILES := $(patsubst %.java,%.class,$(WB_CLASS_FILES))
EXPORTS=--add-exports java.base/jdk.internal.jimage=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.misc=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.module=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.reflect=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.classfile=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.classfile.attribute=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.classfile.constantpool=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.access=ALL-UNNAMED

CTW_MAIN_CLASS = sun.hotspot.tools.ctw.CompileTheWorld
CTWRUNNER_MAIN_CLASS = sun.hotspot.tools.ctw.CtwRunner

.PHONY: clean cleantmp

all: $(DST_DIR)/ctw.zip cleantmp

clean: cleantmp
	@rm -rf $(DST_DIR)

cleantmp:
	@rm -rf filelist wb_filelist manifest.mf
	@rm -rf $(BUILD_DIR)

$(DST_DIR):
	@mkdir -p $@

$(DST_DIR)/ctw.sh: $(DST_DIR)
	echo '$${JAVA_HOME}/bin/java $${JAVA_OPTIONS} $(EXPORTS) -XX:-UseCounterDecay -Xbatch "-XX:CompileCommand=exclude,java/lang/invoke/MethodHandle.*" -XX:+UnlockDiagnosticVMOptions -XX:+WhiteBoxAPI -Xbootclasspath/a:wb.jar -jar ctw.jar $$@' > $@
	chmod a+x $@

$(DST_DIR)/ctwrunner.sh: $(DST_DIR)
	echo '$${JAVA_HOME}/bin/java $${JAVA_OPTIONS} -Dtest.jdk=$${JAVA_HOME} -cp ctw.jar $(CTWRUNNER_MAIN_CLASS) $$@' > $@
	chmod a+x $@

$(DST_DIR)/ctw.jar: filelist $(DST_DIR)/wb.jar
	@mkdir -p $(OUTPUT_DIR)
	$(JAVAC) $(EXPORTS) -sourcepath $(SRC_DIR) -d $(OUTPUT_DIR) -cp $(DST_DIR)/wb.jar @filelist
	$(JAR) --create --file=$@ --main-class $(CTW_MAIN_CLASS) -C $(OUTPUT_DIR) .
	@rm -rf $(OUTPUT_DIR)

$(DST_DIR)/wb.jar: wb_filelist $(DST_DIR)
	$(JAVAC)  -sourcepath $(TESTLIBRARY_DIR) \
		-d $(DST_DIR) \
		-cp $(OUTPUT_DIR) \
		@wb_filelist
	cd $(DST_DIR); $(JAR) --create --file=wb.jar $(WB_CLASS_FILES)

$(DST_DIR)/ctw.zip: $(DST_DIR)/ctw.sh $(DST_DIR)/ctwrunner.sh $(DST_DIR)/wb.jar $(DST_DIR)/ctw.jar $(DST_DIR)/ctwrunner.sh
	zip -j $@ $?

wb_filelist: $(WB_SRC_FILES)
	@rm -f $@
	@echo $(WB_SRC_FILES) > $@

filelist: $(SRC_FILES) $(LIB_FILES)
	@rm -f $@
	@echo $(SRC_FILES) $(LIB_FILES) > $@

=== debian/changelog ===
openjdk-21 (21.0.9~8ea-1) unstable; urgency=medium

  * OpenJDK 21.0.9 early access, build 8.

  [ Matthias Klose ]
  * d/rules: Let the install target depend on the build target. Closes: #1105471.

  [ Vladimir Petko ]
  * d/t/problems.csv: Synchronize problem list.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 27 Sep 2025 13:52:21 +0200

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-21-jre-headless
Restrictions: allow-stderr, superficial

Test-Command: javac --version
Depends: openjdk-21-jdk-headless
Restrictions: allow-stderr, superficial

Tests: hotspot-autopkgtest.sh
Depends: @, jtreg7 (>= 7.3.1+1~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree

Tests: jdk-autopkgtest.sh
Depends: @, jtreg7 (>= 7.3.1+1~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree

Tests: dependencies.sh
Depends: @, build-essential, bash
Restrictions: allow-stderr, skippable, flaky

=== debian/watch ===
--- 
+++ 
@@ -1,6 +1,6 @@
 version=4
 opts=\
-repack,\
+repack,repacksuffix=ea,oversionmangle=s/\+(\d+)/\~$1/,dversionmangle=s/\~(\d*)ea$/\+$1/,\
 compression=xz, \
     https://github.com/openjdk/jdk21u/tags \
     (?:.*?/)?jdk-(21[\+\.\d]*)\.tar\.gz
